DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | List of all members
DSRIncludedTemplateNodeCursor Class Reference

Class implementing a document tree node cursor. More...

Inheritance diagram for DSRIncludedTemplateNodeCursor:

## Public Member Functions
| DSRIncludedTemplateNodeCursor ()
| default constructor
| DSRIncludedTemplateNodeCursor (const DSRIncludedTemplateNodeCursor &cursor)
| copy constructor More...
| DSRIncludedTemplateNodeCursor (DSRDocumentTreeNode *node, const DSRPositionCounter *position=NULL)
| constructor. More...
virtual | ~DSRIncludedTemplateNodeCursor ()
| destructor
DSRIncludedTemplateNodeCursor & | operator= (const DSRIncludedTemplateNodeCursor &cursor)
| assignment operator More...
DSRIncludedTemplateNodeCursor & | operator= (DSRDocumentTreeNode *node)
| assignment operator. More...
virtual const DSRDocumentTreeNode * | getChildNode () const
| get pointer to first child node. More...
virtual size_t | countChildNodes (const OFBool searchIntoSub=OFTrue) const
| count number of children of the current node. More...
virtual size_t | goDown ()
| goto first child node (one level down) More...
virtual size_t | iterate (const OFBool searchIntoSub=OFTrue)
| iterate over all nodes (starting from current position) More...
Public Member Functions inherited from DSRTreeNodeCursor< DSRDocumentTreeNode >
| DSRTreeNodeCursor ()
| default constructor
| DSRTreeNodeCursor (const DSRTreeNodeCursor< DSRDocumentTreeNode > &cursor)
| copy constructor More...
| DSRTreeNodeCursor (DSRDocumentTreeNode *node, const DSRPositionCounter *position=NULL)
| constructor. More...
virtual | ~DSRTreeNodeCursor ()
| destructor
DSRTreeNodeCursor< DSRDocumentTreeNode > & | operator= (const DSRTreeNodeCursor< DSRDocumentTreeNode > &cursor)
| assignment operator More...
DSRTreeNodeCursor< DSRDocumentTreeNode > & | operator= (DSRDocumentTreeNode *node)
| assignment operator. More...
virtual void | clear ()
| clear all member variables. More...
virtual OFBool | isValid () const
| check whether cursor currently points to a valid node More...
OFBool | hasParentNode () const
| check whether the current node has a parent More...
OFBool | hasChildNodes () const
| check whether the current node has any children More...
OFBool | hasPreviousNode () const
| check whether the current node has a preceding sibling More...
OFBool | hasNextNode () const
| check whether the current node has a following sibling More...
OFBool | hasSiblingNodes () const
| check whether the current node has any siblings More...
virtual DSRDocumentTreeNode * | getNode () const
| get pointer to current node More...
virtual const DSRDocumentTreeNode * | getParentNode () const
| get pointer to parent node. More...
virtual const DSRDocumentTreeNode * | getPreviousNode () const
| get pointer to previous node. More...
virtual const DSRDocumentTreeNode * | getNextNode () const
| get pointer to next node. More...
virtual size_t | gotoFirst ()
| goto first node on the same level (first sibling). More...
virtual size_t | gotoLast ()
| goto last node on the same level (last sibling). More...
virtual size_t | gotoPrevious ()
| goto previous node on the same level (preceding sibling) More...
virtual size_t | gotoNext ()
| goto next node on the same level (following sibling) More...
virtual size_t | goUp ()
| goto parent node (one level up) More...
virtual size_t | gotoParent ()
| goto parent node (one level up) More...
virtual size_t | gotoChild ()
| goto first child node (one level down) More...
size_t | gotoNode (const size_t searchID)
| set cursor to specified node. More...
size_t | gotoNode (const OFString &position, const char separator='.')
| set cursor to specified node. More...
size_t | gotoNode (const DSRTreeNodeAnnotation &annotation)
| set cursor to specified node. More...
size_t | gotoNode (const DSRDocumentTreeNode &nodeValue)
| set cursor to specified node. More...
size_t | getNodeID () const
| get current node ID. More...
size_t | getLevel () const
| get current level. More...
DSRPositionCounter & | getPositionCounter ()
| get reference to internal position counter. More...
const OFString & | getPosition (OFString &position, const char separator='.') const
| get position string of the current node. More...

## Additional Inherited Members
Protected Member Functions inherited from DSRTreeNodeCursor< DSRDocumentTreeNode >
void | swap (DSRTreeNodeCursor< DSRDocumentTreeNode > &cursor)
| fast, non-throwing swap function. More...
void | clearNodeCursorStack ()
| clear the internal node cursor stack
const DSRTreeNodeCursor< DSRDocumentTreeNode > & | getCursor () const
| get cursor More...
void | setCursor (const DSRTreeNodeCursor< DSRDocumentTreeNode > &cursor)
| set cursor to specified object More...
size_t | setCursor (DSRDocumentTreeNode *node)
| set cursor to specified node. More...
DSRDocumentTreeNode * | getChild () const
| get pointer to first child node More...
Protected Attributes inherited from DSRTreeNodeCursor< DSRDocumentTreeNode >
DSRDocumentTreeNode * | NodeCursor
| pointer to current node
OFStack< DSRDocumentTreeNode * > | NodeCursorStack
| stack of node pointers. Used to store the cursor position of upper levels.
DSRPositionCounter | Position
| counter for the current position within the current level and on upper levels

## Detailed Description

Class implementing a document tree node cursor.

This type of cursor also supports included sub-templates, i.e. the subtree that is managed by an instance of DSRIncludedTemplateTreeNode is also iterated.

## Constructor & Destructor Documentation

## ◆ DSRIncludedTemplateNodeCursor() [1/2]

DSRIncludedTemplateNodeCursor::DSRIncludedTemplateNodeCursor | ( | const DSRIncludedTemplateNodeCursor & | cursor | ) |

copy constructor

Parameters

  cursor | object to be copied

## ◆ DSRIncludedTemplateNodeCursor() [2/2]

DSRIncludedTemplateNodeCursor::DSRIncludedTemplateNodeCursor | ( | DSRDocumentTreeNode * | node,
|  | const DSRPositionCounter * | position = `NULL`
| ) |  |

constructor.

See comments on DSRTreeNodeCursor<>::setCursor() method.

Parameters

  node | pointer to tree node used to initialize the cursor
  position | optional pointer to position counter that should be used to initialize the internal counter

## Member Function Documentation

## ◆ countChildNodes()

virtual size_t DSRIncludedTemplateNodeCursor::countChildNodes | ( | const OFBool | searchIntoSub = `OFTrue` | ) | const
| virtual

count number of children of the current node.

This method iterates over all children of the current node, either on all sub-levels or on the first child level only.

Parameters

  searchIntoSub | flag indicating whether to search into sub-trees ("deep search") or on the first child level only

Returns
  number of children of the current node, 0 if none

Reimplemented from DSRTreeNodeCursor< DSRDocumentTreeNode >.

## ◆ getChildNode()

virtual const DSRDocumentTreeNode* DSRIncludedTemplateNodeCursor::getChildNode | ( |  | ) | const
| virtual

get pointer to first child node.

Can be used to have a lookup to the first child node without changing the cursor.

Returns
  pointer to first child node (if any), NULL otherwise

Reimplemented from DSRTreeNodeCursor< DSRDocumentTreeNode >.

## ◆ goDown()

virtual size_t DSRIncludedTemplateNodeCursor::goDown | ( |  | ) |
| virtual

goto first child node (one level down)

Returns
  ID of the first child node if successful, 0 otherwise

Reimplemented from DSRTreeNodeCursor< DSRDocumentTreeNode >.

## ◆ iterate()

virtual size_t DSRIncludedTemplateNodeCursor::iterate | ( | const OFBool | searchIntoSub = `OFTrue` | ) |
| virtual

iterate over all nodes (starting from current position)

Parameters

  searchIntoSub | flag indicating whether to search into sub-trees ("deep search") or on the current level only

Returns
  ID of the next node if successful, 0 otherwise

Reimplemented from DSRTreeNodeCursor< DSRDocumentTreeNode >.

## ◆ operator=() [1/2]

DSRIncludedTemplateNodeCursor& DSRIncludedTemplateNodeCursor::operator= | ( | const DSRIncludedTemplateNodeCursor & | cursor | ) |

assignment operator

Parameters

  cursor | object to be copied

Returns
  reference to modified cursor (this object)

## ◆ operator=() [2/2]

DSRIncludedTemplateNodeCursor& DSRIncludedTemplateNodeCursor::operator= | ( | DSRDocumentTreeNode * | node | ) |

assignment operator.

See comments on DSRTreeNodeCursor<>::setCursor() method.

Parameters

  node | node to which the cursor should be set

Returns
  reference to modified cursor (this object)

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/dsritcsr.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1